{**}
{ "InfoLink" Mail Server For DOS v.1.4         }
{ (c) 1992-1996 by Valery Votintsev            }
{     Alma-Ata,Tver, Russia                    }
{     E-mail: vot@infolink.tver.su             }
{     FIDO:   2:5021/2.30                      }
{**}
{ 楤  㭪樨  প ࢥ}
Unit MailServ;
{$N+}
{$S-}
interface

uses
{   GS_dBFld,
   GS_dBase,}
   Dos;

Const
   Version  = '1.40';
   MaxSize  = 100;   {Max Lines in a letter}
   EnCode   = True;
   NoEncode = False;
   F_READ   = 0;      {  File }
   F_WRITE  = 1;      {      Open }
   F_APPEND = 2;      {          Modes }
   WhiteSpace:String[2] = #9#32;
   CRLF:String[2] = #13#10;
   TAB:Char=#9;

Type Letter= Array[1..MaxSize] of string;

Var
{--------------- Configure Parameters -------------------}

{ System Pathes & Files }
ExeDir       : PathStr;
JoinDrive    : NameStr;  { Join any Drive as    }
JoinDir      : PathStr;  {   Joined Directory   }
StartPath    : PathStr;  { Path to Files        }
CurrentPath  : PathStr;  { Current File Path    }
UUPCPath     : PathStr;  { UUPC Path            }
MailBox      : PathStr;  { Mailserver Box       }
Mailer       : PathStr;  { Mail utility (rmail) }
EnCoder      : PathStr;  { UUEncode path        }
IndexName    : PathStr;  { Local Index Name     }
FullIndexName: PathStr;  { Total Index Name     }
NewIndexName : PathStr;  { New   Index Name     }
Header       : PathStr;  { Full List Header File}
NewsHeader   : PathStr;  { NEWS List Header File}
HelpFile     : PathStr;  { Help File for send on "HELP"}
TmpPath      : DirStr;   { Temporary path       }

DomainList   : PathStr;  { File With Enabled Domains List}
BlackList    : PathStr;  { File With Disabled Addresses List}
LocalList    : PathStr;  { File With Local Addresses List}


ServerName   : String;       { Mailserver Name in reply header}
ServerSendAddress: String;   { Mailserver E-Mail for Send     }
ServerRecvAddress: String;   { Mailserver E-Mail for Receive  }
SName        : String;       { Mailserver User Name           }
SMachine     : String;       { MailServer Machine Name        }
UnderLineChar: Char;         { Underline Character for INDEX  }

{ Utilities }
ARCVIEWER    : String;       { Archive Viewer Used            }
VIEWER       : String;       { Text Viewer Used               }
Editor       : String;       { Text Editor Used               }

{ UnPackers }
ARJ   : String;              { ARJ Unpacker                   }
UNZIP : String;              { ZIP Unpacker                   }
RAR   : String;              { RAR Unpacker                   }
LHA   : String;              { LHA/LZH/ICE Unpacker           }
UNARC : String;              { ARC Unpacker                   }

{-------------------------------------------------------------}
Line         : string;       { Current Line                   }
nCounter     : Integer;      { Line Counter                   }
Log,                         { Log File                       }
Post,                        { Output File                    }
Conf         : Text;         { Configuration File             }
cLetter      : Letter;       { Next Letter                    }
Address      : String;       { Recipient Address              }
Limit        : Integer;      { Message Size Limit (KB)        }
Title        : String;       { Title                          }
Debug,
Stop         : Boolean;
LogName,                     { Log File Name                  }
FullName     : String;
ArchiveName  : String;
LocalCost,                   { The cost for local users (cents per KB)}
RemoteCost   : Real;         { The cost remote users (cents per KB)   }


EnableCnt    : integer;
DisableCnt   : integer;
EnableList   : Array[1..100] of string[30];
DisableList  : Array[1..100] of string[30];


{--- Convert Case ---}
Function  UpCase(Ch:Char):Char;
Function  LoCase(Ch:Char):Char;
Function  StUpCase(S:String):String;
Function  StLoCase(S:String):String;

Function GetExeDir:String;
Function LeadZero(w : Word;n:byte) : String;
Function CurrentDate:String;
function LTrim(S : string) : string;
function RTrim(S : string) : string;
function AllTrim(S : string) : string;
Function NextWord(Var S:String;WordDelims:String):string;
Function PadR(Var s:String;Right:Byte):String;
Function Left(S:String;n:byte):String;
Function Substr(S:String;i,n:byte):String;
Function BackPos(S1,S2:String):byte;
Function Right(S:String;n:byte):String;
Function IntValue(S:String):Longint;
Function RealValue(S:String):Real;
Function IsNumeric(S:String):Boolean;
Function Replicate(Strn:String;Numb:Byte):String;
Function ReplaceAll(S,Search,Repl:string):String;
Function Spaces(n:byte):string;
Function MakePath(Name:string):string;
Function DirExists(Strn:String):Boolean;
function FileExists(FileName: string): Boolean;
Function FSize(Name:String):Longint;
Function FOpen(Var F:Text;FileName:PathStr;Mode:Integer):Boolean;
Procedure FErase(Name:String);
Function AccessDisabled(address:string) : boolean;

Function  AddBackSlash(S:string):string;
Procedure UUEncode(InFileName,OutFileName:String);
Procedure GetAddress(Line:String);
Function  GetFName(Line:String):String;
Procedure ReadLetter;{(Var cLetter:Letter);}
Procedure SayLetter; {(Var cLetter:Letter);}
Procedure CONFIG (ConfName:string);
Procedure GetConfig;
Procedure WriteLog(st1,st2:string);
Function  FinSTR(number:comp):string;
Procedure LogOpen;
Procedure LogClose;

implementation

Function GetExeDir:String;
Var
   Dir,ExeDir:DirStr;
   Name:NameStr;
   Ext:ExtStr;
   l:byte absolute Exedir;
begin
  Dir:=FExpand(ParamStr(0));
  FSplit(Dir, ExeDir, Name, Ext);
  If ExeDir[l] = '\' then Dec(l);
  GetExeDir := ExeDir;
end;

{-----------------------------------------------}
{            String Routines                    }
{-----------------------------------------------}
{-----------------------------------------------------------}
Function Replicate(Strn:String;Numb:Byte):String;
{------- Repeat repeated Substring -------------}
Var i:Byte;
    St:String;
Begin
  St:='';
  For i:=1 to Numb do St:=St+Strn;
  Replicate:=St;
end;

{------------------------------------------------}
Function Spaces(n:byte):string;
var s:string;
    i:byte;
begin
  s:='';
  For i:=1 to n do S:=S+' ';
  Spaces:=S;
end;

{**}
Function IntValue(S:String):Longint;
Var i:integer;
    n:Longint;
Begin
   Val(S,n,i);
   If i <> 0 then IntValue:=0
             else IntValue:=n;
end;

{**}
Function RealValue(S:String):Real;
Var i:integer;
    n:Real;
Begin
   Val(S,n,i);
   If i <> 0 then RealValue:=0
             else RealValue:=n;
end;

Function IsNumeric(S:String):Boolean;
Var i:byte;
begin
  IsNumeric:=True;
  For i:=1 to Length(S) do begin
     If not (S[i] in ['0'..'9']) then begin
        IsNumeric:=False;
        break;
     end;
  end;
end;


{**}
Function  AddBackSlash(S:string):string;
Var l:byte absolute S;
begin
  S:=AllTrim(S);
  If S[l]<>'\' then S:=S+'\';
  AddBackSlash:=S;
end;

{**}
Function NextWord(Var S:String;WordDelims:String):string;
Var i:integer;
    strn:string;
    ls:byte absolute S;
Begin
   i:=1;
   S:=AllTrim(S);
   while (i <= ls) and (Pos(S[i], WordDelims)=0) do begin
      Inc(i);
   end;

   strn:=copy(S,1,i-1);
   If i > ls then i:=ls;
   Delete(S,1,i);

   NextWord:=AllTrim(strn);
end;

{**}
Function LeadZero(w : Word;n:byte) : String;
var
   s : String;
begin

   Str(w:0,s);

   While Length(s) < n do
      s := '0' + s;
        LeadZero := s;
end;


{**}
Function CurrentDate:String;
var
  y, m, d, dow : Word;
  S:string[11];
begin
  s:='';
  GetDate(y,m,d,dow);
  s:=LeadZero(d,2)+'.'+LeadZero(m,2)+'.'+LeadZero(y-1900,2);
  CurrentDate:=s;
end;


{**}
Function ReplaceAll(S,Search,Repl:string):String;
var i,p:byte;
begin
   p:=1;
   While p > 0 do begin
      p:=Pos(Search,S);
      If p>0 then begin
         Delete(S,p,Length(Search));
         Insert(Repl,S,p);
      end;
   end;
   ReplaceAll:=S;
end;

(*
{-----------------------------------------------}
Function Upper(Ch:Char):Char;
{ Convert Char to UPPER case }

var

  OutCH: Char;

begin
  OutCh:=Ch;
  if (Ch>='a') and (Ch<='z') then OutCh:=Chr(Ord(Ch) - $20)
  else if (Ch>='' {rus}) and (Ch<='') then OutCh:=Chr(Ord(Ch) - $20)
                 else if (Ch>='' {rus}) and (Ch<='') then OutCh:=Chr(Ord(Ch) - $50)
                                else if (Ch='') then Ch:='';

 Upper:=OutCh;
end; { Upper }

{--------------  ---------------------------}
Function StUpCase(S:String):String;
var
  i : Integer;
begin
  for i := 1 to Length(s) do
    s[i] := Upper(s[i]);
  StUpCase:=S;
end;

*)
{**}
Function StUpCase(S:String):String;
var
  i : Integer;
begin
  for i := 1 to Length(s) do
    s[i] := Upcase(s[i]);
  StUpCase:=S;
end;

{**}
Function StLoCase(S:String):String;
var
  i : Integer;
begin
  for i := 1 to Length(s) do
    s[i] := Locase(s[i]);
  StLoCase:=S;
end;

{**}
Function UpCase(Ch : Char) : Char; Assembler;
{Return uppercased char, with Russian character support}

Asm
        mov     al,ss:[bp+6]
       { -----------  Convert English Characters }
        CMP     AL,'a'
        JB      @1               { if AL < 'a'          }
        CMP     AL,'z'
        JA      @2               { if AL > 'z'          }
        SUB     AL,20H           { Convert to uppercase }
        JMP     @1
        { -----------  Convert Russian Characters}
@2:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @3
       AND AL,0DFH      { Convert chars "..." }
        JMP     @1
@3:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @4
       SUB AL,050H      { Convert chars "..." }
        JMP     @1
@4:
       CMP AL,''
       JNE @1
       DEC AL           { Convert e: -> E:        }
@1:
END;

{**}
Function Locase(Ch : Char) : Char; Assembler;
{Return lowercased char, with Danish character support  }
Asm
        mov     al,ss:[bp+6]
        { -----------  Convert English Characters  }
        CMP     AL,'A'
        JB      @1                { if AL < 'A'    }
        CMP     AL,'Z'
        JA      @2                { if AL > 'Z'    }
        ADD     AL,20H            { Convert to lowercase }
        JMP     @1
        { -----------  Convert Russian Characters }
@2:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @3
       ADD AL,20H      { Convert chars "..." }
        JMP     @1
@3:
       CMP AL,''
       JB  @1

       CMP AL,''
       JA  @4
       ADD AL,050H      { Convert chars "..." }
        JMP     @1
@4:
       CMP AL,''
       JNE @1
       INC AL           { Convert E: -> e:  }
@1:
END;


{**}
function LTrim(S : string) : string;
    {-Return a string with leading white space removed}
  var
    I : Word;
  begin
    I := 1;
    while (I <= Length(S)) and (S[I] <= ' ') do
      Inc(I);
    Dec(I);
    if I > 0 then
      Delete(S, 1, I);
    LTrim := S;
  end;

{**}
function RTrim(S : string) : string;
    {-Return a string with trailing white space removed}
  var
    SLen : Byte absolute S;
  begin
    while (SLen > 0) and (S[SLen] <= ' ') do
      Dec(SLen);
    RTrim := S;
  end;

{**}
function AllTrim(S : string) : string;
    {-Return a string with leading and trailing white space removed}
  var
    I : Word;
    SLen : Byte absolute S;
  begin
    while (SLen > 0) and (S[SLen] <= ' ') do
      Dec(SLen);

    I := 1;
    while (I <= SLen) and (S[I] <= ' ') do
      Inc(I);
    Dec(I);
    if I > 0 then
      Delete(S, 1, I);

    AllTrim := S;
  end;

{**}
Function PadR(Var s:String;Right:Byte):String;
Var i,k:byte;
st:string;
l:byte absolute st;
begin
st:=s;
If l>=Right then l:=Right
else begin
   k:=Right-l;
   For i:=1 to k do St:=St+' ';
end;
PadR:=st;
end;

{**}
Function Left(S:String;n:byte):String;
Var Stmp:string;
begin
   Stmp:=Copy(S,1,n);
   Left:=Stmp;
end;
{**}
Function Substr(S:String;i,n:byte):String;
begin
   Substr:=Copy(S,i,n);
end;

{**}
Function BackPos(S1,S2:String):byte;
Var i,n,nPos:byte;
    Subs:String;
    l1:byte absolute S1;
    l2:byte absolute S2;
begin
   nPos:=0;
   n:= l2-l1+1;
   For i:= n downto 1 do begin
      If S1=Copy(S2,i,l1) then begin
         nPos:=i;
         i:=1;
      end;
   end;
   BackPos:=nPos;
end;

{**}
Function Right(S:String;n:byte):String;
Var
   l:byte absolute S;
   i:byte;
begin
   i:=l-n+1;
   If i<=0 then i:=1;
   Right:=Copy(S,i,n);
end;


{**}
{-----------------------------------------------}
{            File Routines                      }
{-----------------------------------------------}
Function MakePath(Name:string):string;
Var
   n,Res:integer;
   NewPath:string;
   l:byte absolute NewPath;
   ln:byte absolute Name;

Begin
   NewPath:=CurrentPath;
   If Name<>'' then begin
      If Name[1]='\' then begin
         If ln=1 then NewPath:=''
                 else NewPath:=Name;
      end else begin
         NewPath:=CurrentPath+Name;
      end;

   end;

   IF NewPath[1]='\' then NewPath:=Right(NewPath,l-1);
   IF NewPath[l]='\' then Dec(l);

   MakePath:=NewPath;
end;


{**}
function FileExists(FileName: string): Boolean;
{ Returns True if file exists; otherwise, it returns False }

var
    DirInfo: SearchRec;
begin
   FindFirst(Filename, Archive, DirInfo);
   FileExists:=(DosError = 0);
   doserror:=0;

end;  { FileExists }


{**}
Function DirExists(Strn:String):Boolean;
var
    DirInfo: SearchRec;
begin
         FindFirst(Strn, Directory, DirInfo);
         DirExists:=(DosError = 0);
end;


{**}
Function FSize(Name:String):Longint;
Var F:File of byte;
begin
   assign(F,Name);
   (*$I-*) reset(F); (*$I+*)
   If IoResult = 0 then begin
      Fsize:=FileSize(F);
      Close(F);
   end else FSize:=-1;
end;


{**}
Procedure FErase(Name:String);
Var F:Text;
begin
   If FileExists(Name) then begin
      assign(F,Name);
      Erase(F);
{      Flush(F);}
   end;
end;


{**}
Function FOpen(Var F:Text;FileName:PathStr;Mode:Integer):Boolean;
Var Opened:Boolean;
Begin
   Opened:=False;
   Assign(F,FileName);

   If Mode=F_READ then
      (*$I-*) reset(F) (*$I+*)
   else If Mode=F_WRITE then
      (*$I-*) rewrite(F) (*$I+*)
   else If Mode=F_APPEND then
      (*$I-*) Append(F); (*$I+*)

   If IOResult= 0 then Opened:=True;
   FOpen:=Opened;
end;



{-----------------------------------------------}
{            Mail Routines                      }
{-----------------------------------------------}

{**}
Procedure UUEncode(InFileName,OutFileName:String);
Const
  SP = Byte(' ');

Type
  TTriplet = Array[0..2] of Byte;
  TKwartet = Array[0..3] of Byte;

var Triplets: Array[1..15] of TTriplet;
    kwar: TKwartet;
    FName: String;
    i,j: Integer;
    InF: File;
    OutF: Text;


    procedure Triplet2Kwartet(Triplet: TTriplet; var Kwartet: TKwartet);
    var i: Integer;
    begin
      Kwartet[0] := (Triplet[0] SHR 2);
      Kwartet[1] := ((Triplet[0] SHL 4) AND $30) +
                    ((Triplet[1] SHR 4) AND $0F);
      Kwartet[2] := ((Triplet[1] SHL 2) AND $3C) +
                    ((Triplet[2] SHR 6) AND $03);
      Kwartet[3] := (Triplet[2] AND $3F);
      for i:=0 to 3 do begin
        if Kwartet[i] = 0 then Kwartet[i] := $40;
        Inc(Kwartet[i],SP)
      end
    end; {Triplet2Kwartet}


begin

  IF POS('.', Outfilename) = 0 THEN Outfilename := Outfilename + '.uue';

  Writeln(TAB,'encode: ', Infilename, ' -> ', Outfilename);

  FName:=InFileName;
  i:=BackPos('\',FName);
  If i>0 then FName:=Right(FName,Length(FName)-i);
  i:=Pos(':',FName);
  If i>0 then FName:=Right(FName,Length(FName)-i);

  Assign(InF,InFileName);
  FileMode := $40;
  reset(InF,1);
  if IOResult <> 0 then begin
    writeln(TAB,'Error: could not open file ',InFileName);
    Halt(2)
  end;


  Assign(OutF,OutFileName);
  rewrite(OutF);
  if IOResult <> 0 then begin
    writeln(TAB,'Error: could not create file ',OutFileName);
    Halt(4)
  end;

  writeln(OutF,'begin 644 ',FName);

  repeat
    FillChar(Triplets,SizeOf(Triplets),#0);
    BlockRead(InF,Triplets,SizeOf(Triplets),i);
    write(OutF,Char(SP+i));
    for j:=1 to (i+2) div 3 do begin
      Triplet2Kwartet(Triplets[j],kwar);
      write(OutF,Char(kwar[0]),Char(kwar[1]),Char(kwar[2]),Char(kwar[3]))
    end;
    writeln(OutF)
  until (i < SizeOf(Triplets));

  writeln(OutF,'`');
  writeln(OutF,'end');
  close(InF);
  Flush(OutF);
  close(OutF);

end;



{**}
Procedure GetAddress(Line:String);
Var i,nPos:Integer;
    lAddr:byte absolute Address;
    l:byte absolute Line;

Begin
   { Parse Address Line }
   nPos:=Pos('@',Line);
   If nPos=0 then
      nPos:=Pos('!',Line);
   If nPos=0 then nPos:=l+1;
   While Line[nPos] <> ' ' do Dec(nPos);
   Address:=Right(Line,l-nPos);
   nPos:=Pos(' ',Address);
   If nPos=0 then nPos:=lAddr+1;
   Address:=Left(Address,nPos-1);
   If Left(Address,1)='<' then Address:=Right(Address,lAddr-1);
   If Right(Address,1)='>' then Address:=Left(Address,lAddr-1);

end;

{**}
Function GetFName(Line:String):String;
Var lStr:byte absolute Line;
   nPos:byte;
   FileName:String;
   lFN: byte absolute FileName;
Begin
   nPos:=Pos(' ',Line);
   If nPos=0 then FileName:=''
   else begin
      FileName:=AllTrim(Right(Line,Lstr-nPos));
      nPos:=Pos(' ',FileName);
      If nPos=0 then nPos:=lFN+1;
      FileName:=Left(FileName,nPos-1);
   end;
   GetFName:=FileName;
end;

{**}
Procedure ReadLetter;{(Var cLetter:Letter);}
Var
   Stop:boolean;
   IsHeader:Boolean;

Begin
   nCounter:=0;
   Stop:=False;
   Line:='';
   Address:='';
   IsHeader:=True;

   While not EOF(Post) and not Stop do begin
      Readln(Post,Line);
      Line:=AllTrim(Line);

      If Length(Line) = 0 then IsHeader:=False
      else begin
         If Left(Line,5)='From ' then Stop:=True
         else If Left(Line,6)='From: ' then GetAddress(Line)
         else begin
            If not IsHeader then begin
               If nCounter<MaxSize then begin
                  Inc(nCounter);
                  cLetter[nCounter]:=Line;
               end;
            end;
         end;
      end;
   end;
end;


{**}
Procedure SayLetter; {(Var cLetter:Letter);}
Var i:integer;
Begin
   Writeln('========== New Letter ===========================');
   Writeln('From: ',Address);
   For i:=1 to nCounter do
      Writeln(cLetter[i]);

End;

{**}
Procedure CONFIG (ConfName:string);
Var
   i,lstr,Equ,Comment:byte;
   Line:string;
   Ok:boolean;
   StrConf,
   ParName,Parm:  string;

Begin
   IF not FileExists(ConfName) then begin
      Writeln('');
      Writeln('*** File ',ConfName,' not found!');
      Halt(1);
   end;

   If not FOpen(Conf,ConfName,0) then begin
      writeln('*** Open error of "',ConfName,'"');
      HALT(1);
   end;

   While not EOF(Conf) do begin

      Readln(Conf,StrConf);
      Comment:=Pos('//',StrConf);
      If Comment=0 then
         Comment:=Pos('&&',StrConf);
      If Comment=0 then
         Comment:=Pos(';',StrConf);

      If Comment>0 then
         StrConf:=Substr(StrConf,1,Comment-1);

      Lstr:=Length(StrConf);
      Equ:=Pos('=',StrConf);

      If Equ>0 then begin
         ParName:=AllTrim(StUpCase(Substr(StrConf,1,Equ-1)));
         Parm:=AllTrim(Substr(StrConf,Equ+1,Lstr-Equ));

         If Length(Parm)<>0 then begin
            {*--- Parameters --------------------}
            If      ParName = 'STARTPATH' then STARTPATH:=Parm
            else If ParName = 'TMPPATH'   then TmpPath  :=Parm
            else If ParName = 'JOINDIR'   then JoinDir  :=Parm
            else If ParName = 'JOINDRIVE' then JoinDrive:=Parm
            else If ParName = 'UUPCPATH'  then UUPCPath :=Parm
            else If ParName = 'MAILBOX'   then MAILBOX  :=Parm
            else If ParName = 'MAILER'    then Mailer   :=Parm
            else If ParName = 'ENCODER'   then EnCoder  :=Parm
            else If ParName = 'HELPFILE'  then HELPFILE :=Parm
            else If ParName = 'HEADER'    then HEADER :=Parm
            else If ParName = 'NEWSHEADER'then NEWSHEADER :=Parm
            else If ParName = 'INDEXNAME' then INDEXNAME :=Parm
            else If ParName = 'NEWINDEXNAME' then NEWINDEXNAME :=Parm
            else If ParName = 'FULLINDEXNAME' then FULLINDEXNAME :=Parm
            else If ParName = 'LOCALCOST' then LocalCost :=RealValue(Parm)
            else If ParName = 'REMOTECOST'then RemoteCost :=RealValue(Parm)
            else If ParName = 'SERVERSENDADDRESS' then ServerSendAddress:=Parm
            else If ParName = 'SERVERRECVADDRESS' then ServerRecvAddress:=Parm
            else If ParName = 'UNDERLINECHAR' then UnderlineChar :=Parm[1]
            else If ParName = 'EDITOR'    then EDITOR :=Parm
            else If ParName = 'VIEWER'    then VIEWER :=Parm
            else If ParName = 'ARCVIEWER' then ARCVIEWER :=Parm
            else If ParName = 'ARJ'       then ARJ :=Parm
            else If ParName = 'UNZIP'     then UNZIP :=Parm
            else If ParName = 'RAR'       then RAR :=Parm
            else If ParName = 'LHA'       then LHA :=Parm
            else If ParName = 'UNARC'     then UNARC :=Parm;
         end;
      end;
   end; {While}

   {$I-} Close(Conf); {$I+}

end;


{**}
{           Read Enabled Domains List               }
Procedure GetEnabledList;
Var
   i,lstr,Comment:byte;
   Line:string;
   StrConf:  string;

Begin
   EnableCnt:=0;
   IF not FileExists(ExeDir+'\'+DomainList) then begin
      Writeln('');
      Writeln('*** WARNING: File ',DomainList,' not found!');
   end else begin

      If not FOpen(Conf,ExeDir+'\'+DomainList,0) then begin
         writeln('*** Open error of "',DomainList,'"');
         HALT(1);
      end else begin

         While not EOF(Conf) do begin

            Readln(Conf,StrConf);
            Comment:=Pos('//',StrConf);
            If Comment=0 then
               Comment:=Pos('&&',StrConf);
            If Comment=0 then
               Comment:=Pos(';',StrConf);

            If Comment>0 then
               StrConf:=Substr(StrConf,1,Comment-1);

            Lstr:=Length(StrConf);
            If lstr>0 then begin
               Inc(EnableCnt);
               EnableList[EnableCnt]:=StUpcase(AllTrim(StrConf));
            end;
         end;

         {$I-} Close(Conf); {$I+}

      end;
   end;
end;

{**}
{           Read Disabled Address List               }
Procedure GetDisabledList;
Var
   i,lstr,Comment:byte;
   Line:string;
   StrConf:  string;

Begin
   DisableCnt:=0;
   IF not FileExists(ExeDir+'\'+BlackList) then begin
      Writeln('');
      Writeln('*** WARNING: File ',BlackList,' not found!');
   end else begin

      If not FOpen(Conf,ExeDir+'\'+BlackList,0) then begin
         writeln('*** Open error of "',BlackList,'"');
         HALT(1);
      end else begin

         While not EOF(Conf) do begin

            Readln(Conf,StrConf);
            Comment:=Pos('//',StrConf);
            If Comment=0 then
               Comment:=Pos('&&',StrConf);
            If Comment=0 then
               Comment:=Pos(';',StrConf);
            If Comment=0 then
               Comment:=Pos(';',StrConf);

            If Comment>0 then
               StrConf:=Substr(StrConf,1,Comment-1);

            Lstr:=Length(StrConf);
            If lstr>0 then begin
               Inc(DisableCnt);
               DisableList[DisableCnt]:=StUpcase(AllTrim(StrConf));
            end;
         end;

         {$I-} Close(Conf); {$I+}

      end;
   end;

end;



{**}
Procedure GetConfig;
Var i:integer;
   StrConf:string;
Begin
   {--------------- Configure Parameters -------------------}

   { System Path & Files }
   ServerName   := 'InfoLink';     { Mailserver Name in reply header}
   ServerSendAddress:= 'mailserv@infolink.tver.su'; { Mailserver E-Mail}
   ServerRecvAddress:= 'ms@infolink.tver.su'; { Mailserver E-Mail}
   StartPath    := '';             { Relative Path to Files}
   MailBox      := 'mailserv';     { Mailserver Box}
   Mailer       := 'c:\uupc\rmail.exe';    { Mailer }
   Encoder      := 'c:\uupc\uuencode.exe'; { uuencode path }
   UUPCPath     := 'c:\uupc';      { UUPC Path}
   IndexName    := 'INDEX.';       { Local index name}
   NewIndexName := 'NEWINDEX.';    { New index name}
   FullIndexName:= 'FULLINDX.';    { Total index name}
   Header       := 'MAILSERV.HDR'; { Full List Header File       }
   NewsHeader   := 'MAILSERV.NEW'; { News List Header File       }
   HelpFile     := 'MAILSERV.HLP'; { Help File for send on "HELP"}
   TmpPath      := 'c:\tmp';       { Temporary Path      }
   UnderLineChar:= '=';            { Underline Character for INDEX}

   DomainList   := 'MAILSERV.ENA'; { File With Enabled Domains List}
   BlackList    := 'MAILSERV.DIS'; { File With Disabled Addresses List}
   LocalList    := 'MAILSERV.LOC'; { File With Local Addresses List}
   LocalCost    := 0.01;
   RemoteCost   := 0.05;


   { Utilities }
   ARCVIEWER:= 'arcview.exe';      { Archive Viewer Used }
   VIEWER   := 'view.com';         { Text Viewer Used    }
   Editor   := 'me';               { Text Editor Used    }
   Limit    := 64;                 { Extent Limit in K   }

   { UnPackers }
   ARJ  := 'c:\archive\arj.exe';     { ARJ Unpacker         }
   UNZIP:= 'c:\archive\pkunzip.exe'; { ZIP Unpacker         }
   RAR  := 'c:\archive\rar.exe';     { RAR Unpacker         }
   LHA  := 'c:\archive\lha.exe';     { LHA/LZH/ICE Unpacker }
   UNARC:= 'c:\archive\pkxarc.com';  { ARC Unpacker         }

   ExeDir := GetExeDir;
   {-----------------------------------------------------}

   Title  :='Mail Server v.'+Version+' (c) 1993-1996 by Valery Votintsev';
   Stop   :=False;

   Config(ExeDir+'\mailserv.ini'); {Get config parameters}

   StrConf:=ServerSendAddress;

   SName:=NextWord(StrConf,'@');    {User Name   }
   SMachine:=NextWord(StrConf,'.'); {Machine Name}

   If Right(UUPCPath,1)='\' then Delete(UUPCPath,Length(UUPCPath),1);

   StartPath:=StUpcase(StartPath);
   If Right(StartPath,1)<>'\' then StartPath:=StartPath + '\';

   If Right(TmpPath,1)<>'\' then TmpPath:=TmpPath + '\';

   CurrentPath:='';
   FullName   :=StartPath+FullIndexName;
   ArchiveName:=FullName;

   i:=Pos('.',ArchiveName);
   If i>0 then ArchiveName:=Left(ArchiveName,i-1);

   GetEnabledList;  { Read Enabled Domains List }
   GetDisabledList; { Read Disabled Address List }


If Debug then begin
  WriteLog('      Config Parameters','');
  WriteLog('      STARTPATH         = ', STARTPATH);
  WriteLog('      TMPPATH           = ', TmpPath  );
  WriteLog('      JOINDIR           = ', JoinDir  );
  WriteLog('      JOINDRIVE         = ', JoinDrive);
  WriteLog('      UUPCPATH          = ', UUPCPath );
  WriteLog('      MAILBOX           = ', MAILBOX  );
  WriteLog('      MAILER            = ', Mailer   );
  WriteLog('      ENCODER           = ', EnCoder  );
  WriteLog('      HELPFILE          = ', HELPFILE );
  WriteLog('      HEADER            = ', HEADER   );
  WriteLog('      NEWSHEADER        = ', NEWSHEADER);
  WriteLog('      INDEXNAME         = ', INDEXNAME );
  WriteLog('      NEWINDEXNAME      = ', NEWINDEXNAME);
  WriteLog('      FULLINDEXNAME     = ', FULLINDEXNAME);
  WriteLog('      SERVERSENDADDRESS = ', ServerSendAddress);
  WriteLog('      SERVERRECVADDRESS = ', ServerRecvAddress);
  WriteLog('      UNDERLINECHAR     = ', UnderlineChar );
  WriteLog('      EDITOR            = ', EDITOR  );
  WriteLog('      VIEWER            = ', VIEWER );
  WriteLog('      ARCVIEWER         = ', ARCVIEWER );
  WriteLog('      ARJ               = ', ARJ );
  WriteLog('      UNZIP             = ', UNZIP );
  WriteLog('      RAR               = ', RAR );
  WriteLog('      LHA               = ', LHA );
  WriteLog('      UNARC             = ', UNARC );
end;

End;

{   OLD VERSION with arrays
{**}
Function AccessDisabled(address:string) : boolean;
var
   res:boolean;   {Disabled:=True!}
   i,le:byte;
   npos:byte;
   la:byte absolute address;
{   domain:string[80];}
begin
{   nPos:=POS('@',address);               {Remove UserName from the Address}
{   If nPos>0 then Delete(address,1,nPos);}
   address:=StUpCase(address);
{   domain := address;                    {Remember the domain address}

   res:=TRUE; {i.e. DISABLED ! }
   { Check for ENABLED domen }
   For i:=1 to EnableCnt do begin
      le:=length(EnableList[i]);
      If le <= la then begin
         If Right(Address,le)=EnableList[i] then begin
            res:=FALSE;
            break;
         end;
      end;
   end;


   {if not found in Enabled List -> Check for DISABLED address }
{   address:=domain;                    {Restore the domain address}
   If res=FALSE then begin
      For i:=1 to DisableCnt do begin
         le:=length(DisableList[i]);
         If le <= la then begin
            If Right(Address,le)=DisableList[i] then begin
               res:=TRUE; {i.e. disabled !}
               break;
            end;
         end;
      end;
   end;

   AccessDisabled:=res;
end;


(*
{**}
{          New Version with DBF/NTX                     }
Function AccessDisabled(address:string):Boolean;
Var
   MyFile  : GS_dBFld_Objt;
   cName,cFound:String;
   nPos:Byte;
   lDisabled:Boolean;
begin

   nPos:=POS('@',address);
   If nPos>0 then Delete(address,1,nPos);

   address:=StLoCase(address);

   cName:=address;


   if not FileExists('ENABLED.DBF') then
   begin
      writeln('File ENABLED.DBF not found.');
      halt;
   end;

   if not FileExists('DISABLED.DBF') then
   begin
      writeln('File DISABLED.DBF not found.');
      halt;
   end;

   MyFile.Init('DISABLED');
   MyFile.Open;
   MyFile.Index('DISABLED');

   MyFile.GetRec(Top_Record);

   lDisabled:=FALSE;

   if address <> '' then begin
If Debug then begin
      writeln('DISABLED:');
end;
      While address<>'' do begin
         if MyFile.Find(address) then begin
If Debug then begin
            writeln('Record Found - ',
                    FieldGet('NAME'),' ',
                    FieldGet('SUBENABLED'));
end;
            lDisabled:=TRUE;
            break;
            end
         else begin
            nPos:=Pos('.',address);
            If nPos=0 then nPos:=Length(address);
            Delete(address,1,nPos);
         end;
      end;

      MyFile.Close; {Close Disabled List}

If Debug then begin
      If address='' then
         Writeln('No Match!!');
end;

      If not lDisabled then begin

         MyFile.Init('ENABLED');
         MyFile.Open;
         MyFile.Index('ENABLED');

         MyFile.GetRec(Top_Record);

         address:=cName;

If Debug then begin
         writeln('ENABLED:');
end;
         While address<>'' do begin
            If MyFile.Find(address) then begin
               cFound:=AllTrim(MyFile.FieldGet('NAME'));
               If (address=Right(cFound,Length(address))) then begin

If Debug then begin
               writeln('Record Found - ',
                       FieldGet('NAME'),' ',
                       FieldGet('SUBENABLED'));
end;
                   break;
                   end
               end
            else begin
               nPos:=Pos('.',address);
               If nPos=0 then nPos:=Length(address);
               Delete(address,1,nPos);
            end;
         end;

         If address='' then begin
If Debug then begin
            Writeln('No Match!!');
end;
            lDisabled:=TRUE;
         end;


         MyFile.Close; {Close Enabled List}
      end;
   end;
   AccessDisabled:=lDisabled;
end;
*)

{**}
Procedure LogOpen;
begin
   If Debug and (LogName <> '') then begin
      Assign(LOG,ExeDir+'\'+LogName);
      If FileExists(LogName) then
         Append(LOG)
      else
         Rewrite(Log);
   end;
end;


{**}
Procedure LogClose;
begin
   If Debug and (LogName <> '') then begin
     Writeln(Log);
     Close(LOG);
   end;
end;


{**}
Procedure WriteLog(st1,st2:string);
Var
  y,m,d,w,hh,mm,ss,s1:word;
begin
  If Debug then begin
    getdate(y,m,d,w);
    gettime(hh,mm,ss,s1);
    Write(LOG,LeadZero(d,2),'.',LeadZero(m,2),'.',LeadZero((y-1900),2),' ',
              LeadZero(hh,2),':',LeadZero(mm,2),':',LeadZero(ss,2),' ');
    Writeln(log,st1,st2);
  end;
end;


{**}
{Convert a Number to string with
 3-digits groups divided by comma }
Function FinSTR(number:comp):string;
Var
   i:integer;
   cStr:string;
begin

   Str(number:100:0,cStr);
   cStr:=AllTrim(cStr);
   i:=Length(cStr)-2;

   While i > 1 do begin
      Insert(',',cStr,i);
      dec(i,3);
   end;

   FinStr:=cStr;
end;




{**}
{$F+}
Procedure MailExit;
begin
   LogClose;
end;

{$F-}


{**}

begin
   LogName:='';
   Debug:=False;
   ExitProc:=@MailExit;
end.


