{**}
{ "InfoLink" Mail Server For DOS v.1.4         }
{ (c) 1992-1996 by Valery Votintsev            }
{     Alma-Ata,Tver, Russia                    }
{     E-mail: vot@infolink.tver.su             }
{     FIDO:   2:5021/2.30                      }
{**}
PROGRAM MS;
{$M 10000, 0, 65536}

{    $ M 19200, 0, 655360}
USES Execute,MailServ,DOS;
Const
   MaxSize = 100;   {Max Line Number in a letter}
   MAXLIMIT = 200;  {Max letter size limit (KB) }
   EnCode = True;
   NoEncode = False;
Type Letter= Array[1..100] of string;

Var
{-----------------------------------------------------------------}
  Post_File,
  Conf_File:string;


  FileName: PathStr;  { Path to file to get }
  LetterCounter,CommandCounter:Integer;
  Log,Reply:Text;
  nExtents:Integer;
  FullFile:Boolean;
  ExtNum:integer;

{**}
Procedure WriteHeader(var OutF:Text;Address:string;Var Subject:string;Num,MaxNum:integer);
Var Str1,Str2:String;
    l:byte;
begin
   Str(MaxNum,Str2);
   l:=length(Str2);  {Number of Digits in Max Extents number}
   Str(Num:l,Str1);  {Current Extent Number}
   For l:=1 to length(Str1) do
      If Str1[l]=' ' then Str1[l]:='0'; {Replace all spaces to nulls }

{   Writeln(OutF,'Sender: mailserv@infolink.alma-ata.su');}
{   Writeln(OutF,'From mailserv Tue Feb 07 19:54:06 1995 remote from infolink');}
{   Writeln(OutF,'From mailserv Mon Jan 01 01:01:01 1994 remote from infolink');}
   Writeln(OutF,'To: ',Address);
   Writeln(OutF,'From: ',ServerSendAddress);
   Write  (OutF,'Subject: ',Subject);

   Write  (  Tab,Subject);

   If MaxNum>1 then begin
      Write(OutF,' Part '+Str1+'/'+Str2);
      Write(' Part '+Str1+'/'+Str2);
   end;
   Writeln;
   Writeln(OutF,'');
   Writeln(OutF,'');
end;

function LongDiv(X: Longint; Y: Integer): Integer;
inline($59/$58/$5A/$F7/$F9);

function longmul(X, Y: Integer): Longint;
inline($5A/$58/$f7/$EA);

{**}
Procedure SendMail(Address,Subject,Body:string;FileName:PathStr);
Var InF,OutF:Text;
    OutFile:PathStr;
    OutSize,MaxSize:LongInt;
    Start:boolean;
   i,n:integer;
   Line,Param:string;
   l:byte absolute Line;
   ExitCode:integer;
   FS:Longint;
Begin

   OutFile:=TmpPath+'TMP.SND';
   FS:=FSize(FileName);
   Start:=True;
   MaxSize:=LongMul(1024,Limit);
   nExtents:=(FS div MaxSize ) +1;
   i:=1;  {Current Extent Number}
   OutSize:=0;

   If not FOpen(InF,FileName,0) then
      Writeln(Tab,'*** MySendMail: Can''t open ',FileName)
   else begin

      Repeat
      If Start then begin
         If not FOpen(OutF,OutFile,1) then begin
            Writeln(Tab,'*** MySendMail: Can''t create ',OutFile);
            Halt(1)
         end;

         If FullFile or (i=ExtNum) then begin
            WriteHeader(OutF,Address,Subject,i,nExtents);

            If ((i=1) and (Body<>'')) then begin
               Writeln(OutF,'> ',Body);
               Writeln(OutF,'');
            end;
         end;

         Start:=False;
         OutSize:=0;
      end;

      Readln(InF,Line);
      Inc(OutSize,l+2);

      If FullFile or (i=ExtNum) then Writeln(OutF,Line);

      If (OutSize>MaxSize) or EOF(InF) then begin
         If FullFile or (i=ExtNum) then Writeln(OutF,'');
         Close(OutF);

         If FullFile or (i=ExtNum) then begin
            Param:= {Address+}' -t -f'+OutFile;
            SwapVectors;

            Exec(Mailer,Param);

            ExitCode := DOSExitCode; { Return the exit code for error trapping }
            SwapVectors;
            Writeln(Tab,'ExitCode=',ExitCode);

         end;

         Start:=True;
         Inc(i);
      end;
      until EOF(InF);

      Close(InF);
   end;

end;

{**}
Procedure SendErrorMessage(Line:string;Message:String);
Var OutF:Text;
   Body:String;
   FullName:PathStr;
Begin
   FullName:=TmpPath+'TMP.ERR';
   If FOpen(OutF,FullName,1) then begin
      Writeln(OutF,'');
      Close(OutF);
      Body:=Line+CRLF+'  '+Message;
      SendMail(Address,ServerName+' Mailserver Reply',Body,FullName);
   end;
   Stop:=True;
end;

{**}
Procedure SendFile(Line:String);
{Procedure SendFile(FileName:PathStr;Subject,Body:String;CodeIt:Boolean);}
Var
   FileName:PathStr;
   Subject,Body:String;
   CodedName:PathStr;
   i,n:integer;
{   JustName:String;}
   nPos:byte;
   Path: DirStr;
   OnlyName: NameStr;
   Ext: ExtStr;
   Result:integer;
   Param:String;
   Label Quit;
Begin

   FullFile:=False;
   FileName:=GetFName(Line);
   nPos:=Pos(FileName,Line);
   Delete(Line,nPos,Length(FileName));

   If FileName[1]='-' then begin
      For nPos:=2 to length(Filename) do begin
         If not (FileName[nPos] in ['0'..'9']) then begin
            FullFile:=True;
            break;
         end;
      end;

   end else begin
      FullFile:=True;
   end;

   If not FullFile then begin
      Delete(FileName,1,1);
      Val(FileName,ExtNum,Result);
      If (Result<>0) or (ExtNum<1) or (ExtNum>9999) then begin
         {Say Error}
         Writeln(Reply,Tab,'Bad extent number. command ignored.');
         Writeln(      Tab,'Bad extent number. command ignored.');
         Goto Quit;
      end;
      FileName:=GetFName(Line);
   end;

   If (Pos('*',FileName) > 0) or (Pos('?',FileName) > 0) then begin
      {Say Error}
      Writeln(Reply,Tab,'Sorry, wildcards disabled. command ignored.');
      Writeln(      Tab,'Sorry, wildcards disabled. command ignored.');
      Goto Quit;
   end;

   FileName:=ReplaceAll(FileName,'/','\');
   nPos:=BackPos('\',FileName);
   If nPos>0 then begin
      Path:= Left(FileName,nPos);
      Param:=Right(FileName,Length(FileName)-nPos);
   end else begin
      Path:='';
      Param:=FileName;
   end;

   Path:=MakePath(Path);

   FullName:=StartPath;
   If Path<>'' then FullName:=FullName + Path + '\';

   FullName:=FullName + Param;

   If FileExists(FullName) then begin
      CodedName:=FullName;              {Sended File Name}
      FSplit(FullName,Path, OnlyName, Ext);

      CodedName:=TmpPath+'TMP.UUE';  {uuencoded file name}
      FErase(CodedName);

      UUEncode(FullName,CodedName);
      (*
         Param:=FileName+' '+CodedName;
         SwapVectors;
         Exec(Encoder, Param);
         ExitCode := DOSExitCode; { Return the exit code for error trapping }
         SwapVectors;
       *)

      Subject:=ServerName+': '+OnlyName+Ext;
      SendMail(Address,Subject,'',CodedName);
      Writeln(Log,Address,' ',CurrentPath+FileName,' ',FSize(FullName),' ',CurrentDate);
      Writeln(Reply,Tab,FileName,' (',FSize(FullName),') sended in ',nExtents,' extents.');
      Writeln(      Tab,FileName,' (',FSize(FullName),') sended in ',nExtents,' extents.');

   end else begin
      Writeln(Reply,Tab,'File ',FileName,' not found.');
      Writeln(      Tab,'File ',FileName,' NOT FOUND.');
   end;
Quit:
end;


{**}
Procedure SendHelp;
Begin
   Writeln(Reply,Tab,'HELP Sended.');
   Writeln(      Tab,'HELP Sended.');
   SendMail(Address,ServerName+' Mailserver Help','HELP',HelpFile);
   Writeln(Log,Address,' HELP ',FSize(HelpFile),' ',CurrentDate);
end;


{**}
Procedure SendList(Line:string);
Var FullName:string;
    nPos:byte;
    Body:String;
    ListName,Origin,ReplyStr:String;
    Recursive:boolean;
Begin
   Recursive:=False;
   Origin:=line;
   FileName:=GetFName(Line);

   If StUpcase(FileName)='-R' then begin
      nPos:=Pos(FileName,Line);
      Delete(Line,nPos,Length(FileName));
      FileName:=GetFName(Line);
      Recursive:=True;
   end;

   FileName:=ReplaceAll(FileName,'/','\');
   FileName:=StUpCase(MakePath(FileName));
   ReplyStr:=StUpCase(FileName)+ ' Index';

   If Recursive then begin
      ListName:='LIST.LST';
      FullName:='LIST.LST';
      ReplyStr:=StUpCase(FileName)+' Recursive Index';

      SwapVectors;

      Exec('FLIST.EXE',StartPath+FileName+' '+FullName);

      ExitCode := DOSExitCode; { Return the exit code for error trapping }
      SwapVectors;

   end else begin
      If FileName='' then ListName:=IndexName
                     else ListName:=FileName+'\'+IndexName;
      FullName:=StartPath+ListName;
   end;

   If FileExists(FullName) then begin
      SendMail(Address, ServerName+': '+ReplyStr,Origin{'INDEX '+FileName},FullName);
      Writeln(Reply,Tab,ReplyStr,' sended.');
      Writeln(      Tab,ReplyStr,' sended.');
      Writeln(Log,Address,' ',ListName,' ',FSize(FullName),' ',CurrentDate);
      end
   else begin
      Writeln(Reply,Tab,'File or Directory not found.');
      Writeln(      Tab,'File or Directory NOT FOUND!');
   end;
end;


{**}
Procedure SendCont(Line:string); {Send Archive Contents List }
Var FullName:string;
    nPos:byte;
    Body:String;
    ListName,Origin,ReplyStr:String;
    UnPacker,Param:string;
    ListCommand:string;
    TmpFile:Text;

    {----------------------------------------------}
    Function ReadArchiveHeader(FName:String):String;
    Var
      F:File;
      Buf:String;
      i,n:word;
    begin
      ReadArchiveHeader:=UNZIP;
      For n:=1 to 255 do Buf[n]:=#0;
      Buf[0]:=#255;

      Assign(F,FName);
      {$i-}
      Reset(F,1);
      BlockRead(F,Buf[1],255,n);
      If      Pos('RSFX',Buf)>0 then ReadArchiveHeader:=RAR
      else If Pos('RJSX',Buf)>0 then ReadArchiveHeader:=ARJ
      else If Pos('PKLITE',Buf)>0 then ReadArchiveHeader:=UNZIP
      else If Pos('LH''s SFX',Buf)>0 then ReadArchiveHeader:=LHA
      else If Pos('LHice''s SFX',Buf)>0 then ReadArchiveHeader:=LHA;
      Close(F);
      {$i+}
    end;


    {----------------------------------------------}
    Function CheckArchive(FName:String):String;
    Var
      n:byte;
      F:File;
      Ext,Ext2:string;
    begin
      Ext:='   ';
      n:=Pos('.',FName);
      If n > 0 then Ext:=Copy(FName,n+1,3);
      Ext2:=Copy(Ext,2,2);

      CheckArchive:=UNZIP;

      If        Ext='ARJ' then CheckArchive:=ARJ
      else   If (Ext[1]='A') and (IsNumeric(Ext2)) then CheckArchive:=ARJ
      else   If Ext='RAR' then CheckArchive:=RAR
      else   If (Ext[1]='R') and (IsNumeric(Ext2)) then CheckArchive:=RAR
      else   If Ext='ZIP' then CheckArchive:=UNZIP
      else   If Ext='LHA' then CheckArchive:=LHA
      else   If Ext='LZH' then CheckArchive:=LHA
      else   If Ext='ICE' then CheckArchive:=LHA
      else   If Ext='ARC' then CheckArchive:=UNARC
      else   If Ext='EXE' then CheckArchive:=ReadArchiveHeader(FName)
      else   If Ext='COM' then CheckArchive:=ReadArchiveHeader(FName);
    end;


Begin
   Origin:=line;
   FileName:=GetFName(Line);

   FileName:=ReplaceAll(FileName,'/','\');
   FileName:=StUpCase(MakePath(FileName));
   ReplyStr:=ServerName+': '+StUpCase(FileName)+ ' Contents List';

   ListName:='LIST.LST';
{   FullName:='LIST.LST';
}
   If FileName='' then begin
      Writeln(Reply,Tab,'*** File Name not Defined. Command Ignored.');
      Writeln(      Tab,'*** File Name not Defined. Command Ignored.');
   end else begin
      FullName:=StartPath+FileName;

      If not (FileExists(FullName)) then begin
        Writeln(Reply,Tab,'*** File or Directory NOT FOUND.');
        Writeln(      Tab,'*** File or Directory NOT FOUND!');
      end else begin

        UnPacker:=CheckArchive(FullName);

        If      (Unpacker=UNZIP) then ListCommand:='-VB '
        else If (UnPacker=UNARC) then ListCommand:='-V '
        else If (UnPacker=ARJ)   then ListCommand:='L '
        else If (UnPacker=RAR)   then ListCommand:='L '
        else If (UnPacker=LHA)   then ListCommand:='L '
        else                          ListCommand:='V ';

        Param:= ListCommand + FullName +' > '+ListName;

        SwapVectors;

        Exec(UnPacker,Param);

        ExitCode := DOSExitCode; { Return the exit code for error trapping }

        SwapVectors;

        Assign (TmpFile,ListName);
        Append (TmpFile);
        Writeln(TmpFile,'');
        Writeln(TmpFile,'DOS Exit Code = ',ExitCode);
        Close  (TmpFile);

        SendMail(Address, ReplyStr,Origin{'INDEX '+FileName},ListName);
        Writeln(Reply,Tab,'Archive Contents List sended.');
        Writeln(      Tab,'Archive Contents List sended.');
      end;

   end;

end;

{**}
Procedure SetDir(Line:string);
Var n,Res:integer;
    NewPath:string;
    l:byte absolute NewPath;
Begin
   FileName:=GetFName(Line);
   FileName:=ReplaceAll(FileName,'/','\');

   NewPath:=MakePath(FileName);

   If NewPath='' then begin
      CurrentPath:='';
      Writeln(Reply,Tab,'Ok. Dir = \');
      Writeln(      Tab,'Ok. Dir = \');
   end else If DirExists(StartPath+NewPath) then begin
      CurrentPath:=NewPath+'\';
      Writeln(Reply,Tab,'Ok. Dir = ',StUpcase(CurrentPath));
   end else begin
      Writeln(Reply,Tab,'Directory ',StUpcase(NewPath),' not found.');
      Writeln(      Tab,'Directory ',StUpcase(NewPath),' NOT FOUND!');
   end;
end;




{**}
Procedure SetLimit(Line:string);
Var n,Res:integer;
Begin
   FileName:=GetFName(Line);
   Val(FileName,n,Res);
   If (Res = 0) and (n>0) then Limit:= n;
   If Limit > MAXLIMIT then begin
      Limit := MAXLIMIT;
      Writeln(Reply,Tab,'Sorry. MaxSize = ',Limit,' K bytes');
   end else
      Writeln(Reply,Tab,'Ok. Size = ',n,' K bytes');
   Writeln(      Tab,'Ok. Size = ',n,' K bytes');

end;


{**}
Procedure ByeBye(Line:string);
begin
   Stop:=True;
   Writeln(Reply,Tab,'Bye! See later...');
end;

{**}
Procedure ProcessNextCommand(Line:String);
Var
   lStr:byte absolute Line;
   nPos:byte;
   FileName: String;
   Command: String;
Begin

   FullFile:=True;
   nExtents:=1;
   Writeln(Reply,'>  ',Line);
   Writeln(      '>  ',Line);

   nPos:=Pos(' ',Line);

   Command:='';

   If nPos=0 then nPos:=lStr+1;
   Command:=StUpCase(AllTrim(Left(Line,nPos-1)));

   If nPos>lstr then nPos:=lStr;
{   Writeln(Tab,Command,' ',StUpcase(Right(Line,lstr-npos)));}

   If Length(Command)<>0 then begin
      {*--- Parameters --------------------}
      If      Command = 'HELP'    then SendHelp
      else If Command = 'ENCODER' then begin end
      else If Command = 'INDEX'   then SendList(Line)
      else If Command = 'DIR'     then SendList(Line)
      else If Command = 'LS'      then SendList(Line)
      else If Command = 'LIST'    then SendCont(Line)
      else If Command = 'SHOW'    then SendCont(Line)
      else If Command = 'GET'     then SendFile(Line)
      else If Command = 'SEND'    then SendFile(Line)
      else If Command = 'LIMIT'   then SetLimit(Line)
      else If Command = 'SIZE'    then SetLimit(Line)
      else If Command = 'CD'      then SetDir(Line)
      else If Command = 'QUIT'    then ByeBye(Line)
      else If Command = 'BYE'     then ByeBye(Line)
      else If Command = '---'     then ByeBye(Line)
      else begin
         Writeln(Reply,Tab,'Unknown command - ignored. Send HELP please.');
         Writeln(      Tab,'Unknown command - ignored. Send HELP please.');
      end;
   end;

end;


{**}
Procedure ProcessNextLetter;
Var
   i:integer;

Begin
   Stop:=False;

   ReadLetter;{(cLetter);}

   Writeln('========================================');
   Writeln('From: ',Address);

{      SayLetter;{(cLetter);}


   If not FOpen(Reply,'MAILSERV.REP',1) then begin
      Writeln(TAB,'*** Can''t Open MAILSERV.REP');
      Halt;
   end;

   FileName:='';    { File To Get   }
   Limit:=64;       { Default Limit }
   CurrentPath:=''; { Current Path  }

   If AccessDisabled(address) then begin
      Writeln(Reply,'');
      Writeln(Reply,' Sorry, ACCESS DISABLED!');
      Writeln(Reply,'');
      Writeln('*** ACCESS DISABLED');
      FullFile:=TRUE;
   end else begin
      For i:=1 to nCounter do begin
         ProcessNextCommand(cLetter[i]);
         Inc(CommandCounter);
         If Stop then i:=nCounter; {Break}
      end;
   end;

   Close(Reply);
   SendMail(Address,ServerName+': Result of Mailserver Request','','MAILSERV.REP');

end;


{**}
Begin

   GetConfig;        { Get Config Parameters                }
                     { & List of Enabled/Disabled Domains   }

   LetterCounter:=0;
   CommandCounter:=0;

   Writeln('');
   Writeln(Title);   { Draw Title}
   Writeln('');

   IF not FileExists(MailBox) then begin
      Writeln('');
      Writeln('*** File ',MailBox,' not found!  Exit.');
      Halt(1);
   end;

   If not FOpen(Post,MailBox,0) then begin
      writeln('*** Open error of "',post_file,'"');
      HALT(1)
   end;

   If not FOpen(Log,'MAILSERV.LOG',0) then begin
      writeln('*** File "MAILSERV.LOG" not found. Creating.');
      If not FOpen(Log,'MAILSERV.LOG',1) then begin
         writeln('*** Can not create "MAILSERV.LOG". Aborting.');
         HALT(1);
      end else begin
         Close(Log);
      end;
   end;

   If not FOpen(Log,'MAILSERV.LOG',2) then begin
      writeln('*** Can not append to "MAILSERV.LOG". Aborting.');
      HALT(1);
   end;


   While not Stop do begin
      Readln(Post,Line);
      Stop:=(EOF(Post) or (Left(Line,5) = 'From '));
   end;

   nCounter:=1;
   Stop:=False;

   If Left(Line,5) = 'From ' then begin

      While not EOF(Post) do begin
         ProcessNextLetter;
         Inc(LetterCounter);
      end;
   end;

   {$I-} Close(Post); {$I+}
(*   {$I-} Rewrite(Post); {$I+}
   {$I-} Close(Post); {$I+}
*)
   {$I-} Close(Log); {$I+}
   Writeln('------------------------------------');
   Writeln('Total Letters  Handled: ',LetterCounter);
   Writeln('Total Commands Handled: ',CommandCounter);

end.


